SFML - Simple and Fast Multimedia Library

SFML 3.0.1

- Main Page
- Topics
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
sf::SoundRecorder Class Referenceabstract
Audio module

Abstract base class for capturing sound data. More...

`#include <SFML/Audio/SoundRecorder.hpp>`

Inheritance diagram for sf::SoundRecorder:

## Public Member Functions
virtual | ~SoundRecorder ()
| destructor
bool | start (unsigned int sampleRate=44100)
| Start the capture.
void | stop ()
| Stop the capture.
unsigned int | getSampleRate () const
| Get the sample rate.
bool | setDevice (const std::string &name)
| Set the audio capture device.
const std::string & | getDevice () const
| Get the name of the current audio capture device.
void | setChannelCount (unsigned int channelCount)
| Set the channel count of the audio capture device.
unsigned int | getChannelCount () const
| Get the number of channels used by this recorder.
const std::vector< SoundChannel > & | getChannelMap () const
| Get the map of position in sample frame to sound channel.

## Static Public Member Functions
static std::vector< std::string > | getAvailableDevices ()
| Get a list of the names of all available audio capture devices.
static std::string | getDefaultDevice ()
| Get the name of the default audio capture device.
static bool | isAvailable ()
| Check if the system supports audio capture.

## Protected Member Functions
| SoundRecorder ()
| Default constructor.
virtual bool | onStart ()
| Start capturing audio data.
virtual bool | onProcessSamples (const std::int16_t *samples, std::size_t sampleCount)=0
| Process a new chunk of recorded samples.
virtual void | onStop ()
| Stop capturing audio data.

## Detailed Description

Abstract base class for capturing sound data.

`sf::SoundBuffer` provides a simple interface to access the audio recording capabilities of the computer (the microphone).

As an abstract base class, it only cares about capturing sound samples, the task of making something useful with them is left to the derived class. Note that SFML provides a built-in specialization for saving the captured data to a sound buffer (see `sf::SoundBufferRecorder`).

A derived class has only one virtual function to override:

- `onProcessSamples` provides the new chunks of audio samples while the capture happens

Moreover, two additional virtual functions can be overridden as well if necessary:

- `onStart` is called before the capture happens, to perform custom initializations
- `onStop` is called after the capture ends, to perform custom cleanup

The audio capture feature may not be supported or activated on every platform, thus it is recommended to check its availability with the isAvailable() function. If it returns `false`, then any attempt to use an audio recorder will fail.

If you have multiple sound input devices connected to your computer (for example: microphone, external sound card, webcam mic, ...) you can get a list of all available devices through the `getAvailableDevices()` function. You can then select a device by calling `setDevice()` with the appropriate device. Otherwise the default capturing device will be used.

By default the recording is in 16-bit mono. Using the setChannelCount method you can change the number of channels used by the audio capture device to record. Note that you have to decide whether you want to record in mono or stereo before starting the recording.

It is important to note that the audio capture happens in a separate thread, so that it doesn't block the rest of the program. In particular, the `onProcessSamples` virtual function (but not `onStart` and not `onStop`) will be called from this separate thread. It is important to keep this in mind, because you may have to take care of synchronization issues if you share data between threads. Another thing to bear in mind is that you must call `stop()` in the destructor of your derived class, so that the recording thread finishes before your object is destroyed.

Usage example:

class CustomRecorder : public sf::SoundRecorder
{
public:
~CustomRecorder()
{
// Make sure to stop the recording thread
stop();
}
private:
bool onStart() override // optional
{
// Initialize whatever has to be done before the capture starts
...
// Return true to start playing
return true;
}
[[nodiscard]] bool onProcessSamples(const std::int16_t* samples, std::size_t sampleCount) override
{
// Do something with the new chunk of samples (store them, send them, ...)
...
// Return true to continue playing
return true;
}
void onStop() override // optional
{
// Clean up whatever has to be done after the capture ends
...
}
};
// Usage
if (CustomRecorder::isAvailable())
{
CustomRecorder recorder;
if (!recorder.start())
return -1;
...
recorder.stop();
}
sf::SoundRecorder
Abstract base class for capturing sound data.
Definition SoundRecorder.hpp:49
sf::SoundRecorder::onStart
virtual bool onStart()
Start capturing audio data.
sf::SoundRecorder::stop
void stop()
Stop the capture.
sf::SoundRecorder::onProcessSamples
virtual bool onProcessSamples(const std::int16_t *samples, std::size_t sampleCount)=0
Process a new chunk of recorded samples.
sf::SoundRecorder::onStop
virtual void onStop()
Stop capturing audio data.

See also
  `sf::SoundBufferRecorder`

Definition at line 48 of file SoundRecorder.hpp.

## Constructor & Destructor Documentation

## ◆ ~SoundRecorder()

virtual sf::SoundRecorder::~SoundRecorder | ( |  | ) |
| virtual

destructor

## ◆ SoundRecorder()

sf::SoundRecorder::SoundRecorder | ( |  | ) |
| protected

Default constructor.

This constructor is only meant to be called by derived classes.

## Member Function Documentation

## ◆ getAvailableDevices()

static std::vector< std::string > sf::SoundRecorder::getAvailableDevices | ( |  | ) |
| staticnodiscard

Get a list of the names of all available audio capture devices.

This function returns a vector of strings, containing the names of all available audio capture devices.

Returns
  A vector of strings containing the names

## ◆ getChannelCount()

unsigned int sf::SoundRecorder::getChannelCount | ( |  | ) | const
| nodiscard

Get the number of channels used by this recorder.

Currently only mono and stereo are supported, so the value is either 1 (for mono) or 2 (for stereo).

Returns
  Number of channels

See also
  `setChannelCount`

## ◆ getChannelMap()

const std::vector< SoundChannel > & sf::SoundRecorder::getChannelMap | ( |  | ) | const
| nodiscard

Get the map of position in sample frame to sound channel.

This is used to map a sample in the sample stream to a position during spatialization.

Returns
  Map of position in sample frame to sound channel

## ◆ getDefaultDevice()

static std::string sf::SoundRecorder::getDefaultDevice | ( |  | ) |
| staticnodiscard

Get the name of the default audio capture device.

This function returns the name of the default audio capture device. If none is available, an empty string is returned.

Returns
  The name of the default audio capture device

## ◆ getDevice()

const std::string & sf::SoundRecorder::getDevice | ( |  | ) | const
| nodiscard

Get the name of the current audio capture device.

Returns
  The name of the current audio capture device

## ◆ getSampleRate()

unsigned int sf::SoundRecorder::getSampleRate | ( |  | ) | const
| nodiscard

Get the sample rate.

The sample rate defines the number of audio samples captured per second. The higher, the better the quality (for example, 44100 samples/sec is CD quality).

Returns
  Sample rate, in samples per second

## ◆ isAvailable()

static bool sf::SoundRecorder::isAvailable | ( |  | ) |
| staticnodiscard

Check if the system supports audio capture.

This function should always be called before using the audio capture features. If it returns `false`, then any attempt to use `sf::SoundRecorder` or one of its derived classes will fail.

Returns
  `true` if audio capture is supported, `false` otherwise

## ◆ onProcessSamples()

virtual bool sf::SoundRecorder::onProcessSamples | ( | const std::int16_t * | samples,
|  | std::size_t | sampleCount )
| nodiscardprotectedpure virtual

Process a new chunk of recorded samples.

This virtual function is called every time a new chunk of recorded data is available. The derived class can then do whatever it wants with it (storing it, playing it, sending it over the network, etc.).

Parameters

  samples | Pointer to the new chunk of recorded samples
  sampleCount | Number of samples pointed by `samples`

Returns
  `true` to continue the capture, or `false` to stop it

Implemented in sf::SoundBufferRecorder.

## ◆ onStart()

virtual bool sf::SoundRecorder::onStart | ( |  | ) |
| protectedvirtual

Start capturing audio data.

This virtual function may be overridden by a derived class if something has to be done every time a new capture starts. If not, this function can be ignored; the default implementation does nothing.

Returns
  `true` to start the capture, or `false` to abort it

Reimplemented in sf::SoundBufferRecorder.

## ◆ onStop()

virtual void sf::SoundRecorder::onStop | ( |  | ) |
| protectedvirtual

Stop capturing audio data.

This virtual function may be overridden by a derived class if something has to be done every time the capture ends. If not, this function can be ignored; the default implementation does nothing.

Reimplemented in sf::SoundBufferRecorder.

## ◆ setChannelCount()

void sf::SoundRecorder::setChannelCount | ( | unsigned int | channelCount | ) |

Set the channel count of the audio capture device.

This method allows you to specify the number of channels used for recording. Currently only 16-bit mono and 16-bit stereo are supported.

Parameters

  channelCount | Number of channels. Currently only mono (1) and stereo (2) are supported.

See also
  `getChannelCount`

## ◆ setDevice()

bool sf::SoundRecorder::setDevice | ( | const std::string & | name | ) |
| nodiscard

Set the audio capture device.

This function sets the audio capture device to the device with the given `name`. It can be called on the fly (i.e: while recording). If you do so while recording and opening the device fails, it stops the recording.

Parameters

  name | The name of the audio capture device

Returns
  `true`, if it was able to set the requested device

See also
  `getAvailableDevices`, `getDefaultDevice`

## ◆ start()

bool sf::SoundRecorder::start | ( | unsigned int | sampleRate = 44100 | ) |
| nodiscard

Start the capture.

The `sampleRate` parameter defines the number of audio samples captured per second. The higher, the better the quality (for example, 44100 samples/sec is CD quality). This function uses its own thread so that it doesn't block the rest of the program while the capture runs. Please note that only one capture can happen at the same time. You can select which capture device will be used by passing the name to the `setDevice()` method. If none was selected before, the default capture device will be used. You can get a list of the names of all available capture devices by calling `getAvailableDevices()`.

Parameters

  sampleRate | Desired capture rate, in number of samples per second

Returns
  `true`, if start of capture was successful

See also
  `stop`, `getAvailableDevices`

## ◆ stop()

void sf::SoundRecorder::stop | ( |  | ) |

Stop the capture.

See also
  `start`

The documentation for this class was generated from the following file:

- SoundRecorder.hpp